<?php

    echo("NFO converter 1.2.5<br>");
    echo("(c)2006 Lic<br>");
    echo("<br>");

    $file = $_REQUEST["file"];
    if ($file == "") {
        echo("no file specified");
        exit;
    }
    $scheme = $_REQUEST["scheme"];
    if ($scheme == "") {
        preg_match("/.*-(.*).nfo/i", $file, $matches);
        $scheme = strtolower($matches[1]);
    }
    if ($scheme == "") {
        echo("no scheme specified");
        exit;
    }

    switch ($scheme) {
        case "fwyh":
            $mappings = array(
                "ARTIST:" => "/ARTiST\.\.\.\.\[ (.*)[ ]{3}/",
                "RELEASE:" => "/TiTLE\.\.\.\.\.\[ (.*)[ ]{3}/",
                "LABEL:" => "/LABEL\.\.\.\.\.\[ (.*)[ ]{3}/",
                "YEAR:" => "/REL\.DATE\.\.\[ .*-.*-([0-9]{4})/"
            );
            $tracks = array(
                "TRACKNR:" => "/[ ]([0-9]{2}).*[ ].*[ ]{2,}.*[0-9:]{5}/",
                "TRACKNAME:" => "/[ ][0-9]{2}.*?[ ](.*)[ ].*[ ][0-9:]{5}/",
                "TRACKTIME:" => "/[ ][0-9]{2}.*?[ ].*[ ].*[ ]([0-9:]{5})/"
            );
            break;
        case "amok":
            $mappings = array(
                "ARTIST:" => "/[ ]*?(.*) - .* \(c\) [0-9]{4}/",
                "RELEASE:" => "/[ ]*?.* - (.*) \(c\) [0-9]{4}/",
                "LABEL:" => "/Label\.\.\.\.\.: (.*)/",
                "YEAR:" => "/[ ]*?.* - .* \(c\) ([0-9]{4})/"
            );
            $tracks = array(
                "TRACKNR:" => "/[ ]{2}([0-9]{2})[ ].*[0-9:]{5}/",
                "TRACKNAME:" => "/[ ]{2}[0-9]{2}[ ](.*)[0-9:]{5}/",
                "TRACKTIME:" => "/[ ]{2}[0-9]{2}[ ].*([0-9:]{5})/"
            );
            break;
        case "amok2":
            $mappings = array(
                "ARTIST:" => "/Artist\.*: (.*)/",
                "RELEASE:" => "/Album\.*: (.*)/",
                "LABEL:" => "/Label\.*: (.*)/",
                "YEAR:" => "/Rel\.Date\.\.: [0-9]{2}-[0-9]{2}-([0-9]{4})/"
            );
            $tracks = array(
                "TRACKNR:" => "/([0-9]{2})[ ].*[ ]{3,}[0-9:]{5}/",
                "TRACKNAME:" => "/[0-9]{2}[ ](.*)[ ]{3,}[0-9:]{5}/",
                "TRACKTIME:" => "/[0-9]{2}[ ].*[ ]{3,}([0-9:]{5})/"
            );
            break;
        case "vce":
            $mappings = array(
                "ARTIST:" => "/Artist[\.]*(.*)\r/",
                "RELEASE:" => "/Album[\.]*(.*)\r/",
                "LABEL:" => "/Label[\.]*(.*)\r/",
                "YEAR:" => "/Street.*\/([0-9]{4})/"
            );
            $tracks = array(
                "TRACKNR:" => "/([0-9]{2})\.[ ]{3}.*[ ]{2}[0-9:]{5}/",
                "TRACKNAME:" => "/[0-9]{2}\.[ ]{3}(.*)[ ]{2}[0-9:]{5}/",
                "TRACKTIME:" => "/[0-9]{2}\.[ ]{3}.*[ ]{2}([0-9:]{5})/"
            );
            break;
        case "radial":
            $mappings = array(
                "ARTIST:" => "/:[ ]{4,}(.*) - .*[ ]{4,}:\r/",
                "RELEASE:" => "/:[ ]{4,}.* - (.*)[ ]{4,}:\r/",
                "LABEL:" => "/Label.*:(.{19})/",
                "YEAR:" => "/Year.*: ([0-9]{4})/"
            );
            $tracks = array(
                "TRACKNR:" => "/[ ]{3}([0-9]{2})[ ]{6}.*[ ]{2}[0-9:]{5}/",
                "TRACKNAME:" => "/[ ]{3}[0-9]{2}[ ]{6}(.*)[ ]{2}[0-9:]{5}/",
                "TRACKTIME:" => "/[ ]{3}[0-9]{2}[ ]{6}.*[ ]{2}([0-9:]{5})/"
            );
            break;
        case "pyt":
            $mappings = array(
                "ARTIST:" => "/artist      : (.*)\r/",
                "RELEASE:" => "/title       : (.*)\r/",
                "LABEL:" => "/label       : (.*)/",
                "YEAR:" => "/date        : (.*)/"
            );
            $tracks = array(
                "TRACKNR:" => "/([0-9]{2})-.*[ ]{3,}[0-9:]{5}/",
                "TRACKNAME:" => "/[0-9]{2}-(.*)[ ]{3,}[0-9:]{5}/",
                "TRACKTIME:" => "/[0-9]{2}-.*[ ]{3,}([0-9:]{5})/"
            );
            break;
        default:
            $mappings = array(
                "ARTIST:" => "/Artist  : (.*)/",
                "RELEASE:" => "/Title   : (.*)/",
                "LABEL:" => "/Label   : (.*)/",
                "YEAR:" => "/Year    : ([0-9]{4})/"
            );
            $tracks = array(
                "TRACKNR:" => "/([0-9]{2})\..*[ ]{3,}[0-9:]{5}/",
                "TRACKNAME:" => "/[0-9]{2}\.(.*)[ ]{3,}[0-9:]{5}/",
                "TRACKTIME:" => "/[0-9]{2}\..*[ ]{3,}([0-9:]{5})/"
            );
            break;
    }
    
    $newreview = array(
        "COVER:" => "cover.jpg",
        "FORMAT:" => "CD",
        "RELEASETYPE:" => "Album",
        "ARTIST_LINK:" => ""
    );
    
    // special cases - we can get some info from filename
    $releaseformats = array(
        "CDM" => "CD5",
        "CDS" => "CD5",
        "2CD" => "2CD"
    );
    $releasetypes = array(
        "CDM" => "Single",
        "CDS" => "Single",
        "2CD" => "Album"
    );
    $releasetypepatterns = "/.*-(cdm|cds|2cd)-.*/";
    if (preg_match($releasetypepatterns, $file, $matches)) {
        $newreview["RELEASETYPE:"] = $releasetypes[strtoupper($matches[1])];
        $newreview["FORMAT:"] = $releaseformats[strtoupper($matches[1])];
    }
    
    $contents = file_get_contents($file);
    foreach ($mappings as $key => $value) {
        preg_match_all($value, $contents, $matches);
        foreach ($matches[1] as $match) {
            $newreview[$key] = trim($match);
        }
    }
    $newreview["LABEL:"] = str_replace("Records", "", $newreview["LABEL:"]);

    $newtracks1 = array();
    preg_match_all($tracks["TRACKNR:"], $contents, $matches);
    foreach ($matches[1] as $match) {
        $newtracks1[] = trim($match);
    }
    $newtracks2 = array();
    preg_match_all($tracks["TRACKNAME:"], $contents, $matches);
    foreach ($matches[1] as $match) {
        $newtracks2[] = trim($match);
    }
    $newtracks3 = array();
    preg_match_all($tracks["TRACKTIME:"], $contents, $matches);
    foreach ($matches[1] as $match) {
        $newtracks3[] = trim($match);
    }

    $newreviewfile = fopen("new_review.txt", "w");
    foreach($newreview as $key => $value) {
        echo($key.$value."<br>");
        fputs($newreviewfile, $key.$value."\r\n");
    }
    echo("<br>");
    fputs($newreviewfile, "\r\n");
    for ($i = 0; $i < count($newtracks1); $i++) {
        echo("TRACKNR:".$newtracks1[$i]."<br>");
        fputs($newreviewfile, "TRACKNR:".$newtracks1[$i]."\r\n");
        echo("TRACKNAME:".$newtracks2[$i]."<br>");
        fputs($newreviewfile, "TRACKNAME:".$newtracks2[$i]."\r\n");
        echo("TRACKTIME:".$newtracks3[$i]."<br>");
        fputs($newreviewfile, "TRACKTIME:".$newtracks3[$i]."\r\n");
    }
    echo("<br>");
    fputs($newreviewfile, "\r\n");
    echo("REVIEW:<br>");
    fputs($newreviewfile, "REVIEW:\r\n");
    echo("AUTHOR:Lic<br>");
    fputs($newreviewfile, "AUTHOR:Lic\r\n");
    fclose($newreviewfile);
    
    // delete file
	unlink($file);
	print("NFO file is removed.<br>");
    
    echo("<br>");
    echo("<a href=\"new_review.txt\">Download new_review.txt</a>");

?>
