<?php

// Lev's Reviews Machine
// (c)2005-2006 Lev Levin

// This class is responsible for handling of images
class Image {
    // path to image file
    var $path = "";
    // image width
    var $width = 0;
    // image height
    var $height = 0;
    // constructor
    function Image($imagepath) {
        $this->set_path($imagepath);
    }
    // function sets image path
    function set_path($imagepath) {
        $this->path = $imagepath;
        if (file_exists($this->path)) {
    		list($width, $height, $type, $attr) = getimagesize($imagepath);
            $this->height = $height;
            $this->width = $width;
        }
    }
}

// Class handles images and substitutes apsent image with default one
class DefaultImage extends Image {
    // constructor
    function DefaultImage($imagepath) {
        $this->set_path($imagepath);
    }
    // function sets image path
    function set_path($imagepath) {
        if (!file_exists($imagepath))
            $imagepath = "images/not_found.jpg";
        parent::set_path($imagepath);
    }
}

// Class handles covers
class CoverImage extends DefaultImage {
    // constructor
    function CoverImage($imagepath) {
        $this->set_path($imagepath);
    }
    // function sets image path
    function set_path($imagepath) {
		while(strlen($imagepath) < 8) $imagepath = "0".$imagepath;
		$imagepath = "covers/".$imagepath;
        if (file_exists($imagepath.".jpg"))
            $imagepath = $imagepath.".jpg";
        if (file_exists($imagepath.".gif"))
            $imagepath = $imagepath.".gif";
        parent::set_path($imagepath);
    }
}

?>
