<?php

// Lev's Reviews Machine
// (c)2005-2006 Lev Levin

class MenuItem {
    var $name = "";
    var $address = "";
    var $description = "";
    var $delimiter = "";
    function MenuItem($name, $address, $description, $delimiter = "") {
        $this->name = $name;
        $this->address = $address;
        $this->description = $description;
        $this->delimiter = $delimiter;
    }
}

class Menu {
    var $items = array();
	function add_menu_item($menuitem) {
        $this->items[] = $menuitem;
	}
}

class TabsHandler {
    var $items = array();
    var $current;
    function TabsHandler($current) {
        $this->current = $current;
    }
}

class PageEvent {
    var $name;
    var $param1;
    var $param2;
    function PageEvent($name, $param1 = "", $param2 = "") {
        $this->name = $name;
        $this->param1 = $param1;
        $this->param2 = $param2;
    }
}

class RedirectItem {
	function evaluate($address) {}
}

class RequestDispatcher {
	var $items = array();
	function add_redirect_item($redirectitem) {
		$this->items[] = $redirectitem;
	}
	function dispatch($address) {
        foreach ($this->items as $item) {
            $pageevent = $item->evaluate($address);
            if (isset($pageevent)) return $pageevent;
        }
        return new PageEvent("error", array ($address.": wrong request"));
    }
}

class FileInfo {
    var $name = "";
    var $path = "";
    var $modificationdate = "";
    var $size = 0;
    function FileInfo($path) {
        $this->name = basename($path);
        $this->path = $path;
        $this->modificationdate = date("d.m.Y", filemtime($path));
        $this->size = filesize($path);
    }
}

class Page {
    var $elements = array();
    var $sqlconnection;
    function Page($sqlconnection) {
        $this->sqlconnection = $sqlconnection;
    }
    function add_element($element) {
        $this->elements[] = $element;
    }
    function prepare(&$template) {
        for ($i = 0; $i < count($this->elements); $i++) {
            $this->elements[$i]->prepare($template);
        }
    }
}

?>
