<?php

require('page.php');
require('element.php');
require('action.php');

class MainMenu extends Menu {
	function MainMenu() {
		$this->add_menu_item(new MenuItem("Main", "main.php?mode=main",
            "  .", " | "));
		$this->add_menu_item(new MenuItem("Recent", "main.php?mode=recent",
            " 20 ,    .", " | "));
		$this->add_menu_item(new MenuItem("Archive",
            "main.php?mode=archive&type=artists&param=A",
            " .", " | "));
		$this->add_menu_item(new MenuItem("Industrial FAQ",
            "main.php?mode=faq",
            "     Industrial Culture Extended FAQ.",
			" | "));
		$this->add_menu_item(new MenuItem("Guestbook",
            "http://www.guestbook.ru/book.cgi?user=lic0001&amp;action=show",
            "  .",
			" | "));
		$this->add_menu_item(new MenuItem("Forum",
            "../forum",
            ",         .",
			" | "));
		$this->add_menu_item(new MenuItem("Author",
            "main.php?mode=author",
            "  ,        FAQ.",
			" | "));
		$this->add_menu_item(new MenuItem("Programs",
            "main.php?mode=programs",
            " ,     .",
			" | "));
		$this->add_menu_item(new MenuItem("Stories",
            "main.php?mode=stories",
            " ,    ."));
	}
}

class PersonalData extends Menu {
    function PersonalData() {
		$this->add_menu_item(new MenuItem("-", "http://www.spb.ru",
            " :"));
		$this->add_menu_item(new MenuItem("02.02.1976", "", " :"));
		$this->add_menu_item(new MenuItem("Software Developer, StarSoft Labs",
            "http://www.starsoftlabs.com", " :"));
		$this->add_menu_item(new MenuItem("industrial@onego.ru",
            "mailto:industrial@onego.ru", "email:"));
		$this->add_menu_item(new MenuItem("4779746", "http://www.icq.com/4779746#pager", "ICQ UIN:"));
		$this->add_menu_item(new MenuItem("Resume", "resume_en.pdf", "&nbsp;"));
    }
}

class CommonFootMenu extends Menu {
    function CommonFootMenu() {
        $this->add_menu_item(new MenuItem("1997-2006", "", ""));
		$this->add_menu_item(new MenuItem("Lic",
            "mailto:industrial@onego.ru", "E-mail  ."));
    }
}

class NormalRedirectItem extends RedirectItem {
    function evaluate($address) {
        if ($address == "/reviews/main.php") return new PageEvent("main");
        if ($address == "/reviews/main.php?mode=main")
            return new PageEvent("main");
        if ($address == "/reviews/main.php?mode=recent")
            return new PageEvent("recent");
        if ($address == "/reviews/main.php?mode=author")
            return new PageEvent("author");
        if ($address == "/reviews/main.php?mode=faq")
            return new PageEvent("faq");
        if (preg_match("/^\/reviews\/main\.php\?mode=review&id=([0-9]{1,4})$/", $address, $matches))
            return new PageEvent("review", $matches[1]);
        if (preg_match("/^\/reviews\/main\.php\?mode=reviews&id=([0-9]{1,4})$/", $address, $matches))
            return new PageEvent("reviews", "artist", $matches[1]);
        if (preg_match("/^\/reviews\/main\.php\?mode=reviews&type=(artist|label|reviewer|format|year)&id=(.*)$/", $address, $matches))
            return new PageEvent("reviews", $matches[1], $matches[2]);
        if (preg_match("/^\/reviews\/main\.php\?mode=archive&type=(artists|labels|reviewers|formats|years)&param=([A-Z-0-9]{1})$/", $address, $matches))
            return new PageEvent("archive", $matches[1], $matches[2]);
        if ($address == "/reviews/main.php?mode=programs")
            return new PageEvent("programs");
        if (preg_match("/^\/reviews\/main\.php\?mode=story&file=(tale[0-9]{3}\.txt)$/", $address, $matches))
            return new PageEvent("story", $matches[1]);
        if ($address == "/reviews/main.php?mode=stories")
            return new PageEvent("stories");
        if ($address == "/reviews/main.php?mode=upload")
            return new PageEvent("upload");
        if ($address == "/reviews/main.php?mode=search")
            return new PageEvent("search", $_REQUEST["TYPE"], $_REQUEST["SEARCH"]);
        if (preg_match("/^\/reviews\/main\.php\?mode=discuss&ouid=([0-9]{1,4})$/", $address, $matches))
            return new PageEvent("discuss", $matches[1]);
        if (preg_match("/^\/reviews\/main\.php\?mode=action&type=(news|changes|review|actions)$/", $address, $matches))
            return new PageEvent("action", $matches[1]);
        if (preg_match("/^\/reviews\/main\.php\?mode=action&type=(nfo)&file=(.*)$/", $address, $matches))
            return new PageEvent("action", $matches[1], $matches[2]);
    }
}

class BonusRedirectItem extends RedirectItem {
    function evaluate($address) {
        if ($address == "/index.html" || $address == "/main")
            return new PageEvent("main");
        if ($address == "/recent.htm" || $address == "/recent")
            return new PageEvent("recent");
        if ($address == "/industrial_faq.htm" || $address == "/faq")
            return new PageEvent("faq");
        if ($address == "/author.htm" || $address == "/author")
            return new PageEvent("author");
        if ($address == "/programs.htm" || $address == "/programs")
            return new PageEvent("programs");
        if ($address == "/stories.htm" || $address == "/stories")
            return new PageEvent("stories");
        if ($address == "/upload")
            return new PageEvent("upload");
    }
}

class OldStyleRedirectItem extends RedirectItem {
    var $meta;
    function OldStyleRedirectItem($metadata) {
        $this->meta = $metadata;
    }
    function evaluate($address) {
	if ($address == '' || $address == '/')
		return new PageEvent("main");
	if (preg_match("/^.*?\/[a-z]{1}\/(.{1,})\/(.{1,})\.htm$/", $address, $matches)) {
            if ($this->meta->search_old_release($matches[1], $matches[2])) {
                return new PageEvent("review", $this->meta->data[0]->ouid);
            }
        }
	if (preg_match("/^.*?\/[a-z]{1}\/(.{1,})\/(index.html)?$/", $address, $matches)) {
            if ($this->meta->search_old_artist($matches[1])) {
                return new PageEvent("reviews", "artist", $this->meta->data[0]->ouid);
            }
        }
        if (preg_match("/^\/([a-zA-Z_0-9]*)\/?$/", $address, $matches)) {
            if ($this->meta->search_artist($matches[1])) {
                return new PageEvent("reviews", "artist", $this->meta->data[0]->ouid);
            }
        }
    }
}

class IORDispatcher extends RequestDispatcher {
    function IORDispatcher($metadata) {
        $this->add_redirect_item(new NormalRedirectItem());
        $this->add_redirect_item(new BonusRedirectItem());
        $this->add_redirect_item(new OldStyleRedirectItem($metadata));
    }
}

class CommonPage extends Page {
    function CommonPage() {
        $this->add_element(new ImageElement("LOGO", "iorimages/logo.gif"));
        $this->add_element(new MenuElement("TOP", new MainMenu()));
    }
}

class ErrorPage extends CommonPage {
    function ErrorPage($errormessage) {
        parent::CommonPage();
		$this->add_element(new MenuElement("FOOT", new CommonFootMenu()));
		$this->add_element(new ErrorElement("GLOBAL", $errormessage));
    }
}

class MainPage extends CommonPage {
    function MainPage($dataconnection) {
        parent::CommonPage();
        $this->add_element(new MenuElement("NAV", new MainMenu()));
		$this->add_element(new StatisticsElement(new StatisticsMeta($dataconnection)));
		$this->add_element(new ListReviewsElement(new RecentReviewsMeta($dataconnection, 1)));
		$this->add_element(new ReviewsPlanElement(new ReviewPlanMeta($dataconnection)));
		$this->add_element(new NewsElement(new NewsMeta($dataconnection)));
		$this->add_element(new NewsElement(new DatesMeta($dataconnection), "DATES"));
		$this->add_element(new NewsElement(new NoticesMeta($dataconnection), "NOTICES"));
		$this->add_element(new DiscographiesElement(new DiscogsMeta($dataconnection)));
		$this->add_element(new NostalgiaElement(new NostalgiaMeta($dataconnection), "NOSTALGIA"));
		$this->add_element(new MenuElement("FOOT", new CommonFootMenu()));
    }
}

class RecentPage extends CommonPage {
    function RecentPage($dataconnection) {
        parent::CommonPage();
		$this->add_element(new MenuElement("FOOT", new CommonFootMenu()));
		$this->add_element(new ListReviewsElement(new RecentReviewsMeta($dataconnection, 20)));
    }
}

class AuthorPage extends CommonPage {
    function AuthorPage($dataconnection) {
        parent::CommonPage();
		$this->add_element(new MenuElement("FOOT", new CommonFootMenu()));
		$this->add_element(new AuthorPhotoElement("AUTHOR"));
        $this->add_element(new MenuElement("PERSONAL", new PersonalData()));
		$this->add_element(new FileInfoElement("sale.txt", "SALETXT"));
		$this->add_element(new FileInfoElement("mp3_cd_series.txt", "THEMESTXT"));
		$this->add_element(new FileInfoElement("lic_mp3_list.zip", "LICMP3XLS"));
		$this->add_element(new ThanksElement(new ThanksMeta($dataconnection)));
		$this->add_element(new FAQElement(new FAQMeta($dataconnection)));
    }
}

class ReviewPage extends CommonPage {
    function ReviewPage($dataconnection, $reviewid) {
        parent::CommonPage();
        $reviewmeta = new ReviewMeta($dataconnection, $reviewid);
        $releaseouid = $reviewmeta->review[0]->release;
        $releasemeta = new ReleaseMeta($dataconnection, $releaseouid);
        $this->add_element(new ReviewElement($reviewmeta));
        $this->add_element(new ReleaseHeaderElement($releasemeta));
        $menu = new CommonFootMenu();
		$menu->add_menu_item(new MenuItem("All Artist Reviews",
            "main.php?mode=reviews&id=".$releasemeta->info[0]->artistouid, "", " | "));
        if ($releasemeta->info[0]->format != "Live") {
            $link_release = str_replace(" ", "+", $releasemeta->info[0]->releasetitle);
            $link_release = str_replace("/", "+", $link_release);
            $menu->add_menu_item(new MenuItem("Discuss Release",
                "../forum/viewforum.php?f=2", "", " | "));
            $menu->add_menu_item(new MenuItem("Release At Discogs.com",
                "http://www.discogs.com/search?type=releases&q=".$link_release, "", " | "));
            $this->add_element(new ReleaseInfoElement($releasemeta));
            $this->add_element(new TracksElement(new TracksMeta($dataconnection, $releaseouid), "RELINFO."));
        } else {
            $gallerymeta = new GaleryMeta($dataconnection, 1, $reviewid);
            if (count($gallerymeta->data))
                $this->add_element(new GaleryElement($gallerymeta));
            else
                $this->add_element(new ReleaseInfoElement($releasemeta));
        }
        $this->add_element(new ReviewElement($reviewmeta));
		$this->add_element(new MenuElement("FOOT", $menu));
    }
}

class ArtistReviewsPage extends CommonPage {
    function ArtistReviewsPage($dataconnection, $id) {
        parent::CommonPage();
        $menu = new CommonFootMenu();
        $artistmeta = new ArtistReviewsMeta($dataconnection, $id);
        $link_artist = str_replace(" ", "+", $artistmeta->data[0]->listby);
        $link_artist = str_replace("/", "+", $link_artist);
        $menu->add_menu_item(new MenuItem("Artist At Discogs.com",
             "http://www.discogs.com/search?type=artists&q=".$link_artist, "", " | "));
		$this->add_element(new ListReviewsElement($artistmeta));
		$this->add_element(new MenuElement("FOOT", $menu));
		$this->add_element(new SeeAlsoElement(new SeeAlsoMeta($dataconnection, $id)));
    }
}

class LabelReviewsPage extends CommonPage {
    function LabelReviewsPage($dataconnection, $id) {
        parent::CommonPage();
        $menu = new CommonFootMenu();
        $labelmeta = new LabelReviewsMeta($dataconnection, $id);
        $link_label = str_replace(" ", "+", $labelmeta->data[0]->listby);
        $link_label = str_replace("/", "+", $link_label);
        $menu->add_menu_item(new MenuItem("Label At Discogs.com",
             "http://www.discogs.com/search?type=labels&q=".$link_label, "", " | "));
		$this->add_element(new ListReviewsElement($labelmeta));
		$this->add_element(new MenuElement("FOOT", $menu));
    }
}

class ReviewersReviewsPage extends CommonPage {
    function ReviewersReviewsPage($dataconnection, $id) {
        parent::CommonPage();
        $menu = new CommonFootMenu();
		$this->add_element(new ListReviewsElement(new ReviewersReviewsMeta($dataconnection, $id)));
		$this->add_element(new MenuElement("FOOT", $menu));
    }
}

class FormatsReviewsPage extends CommonPage {
    function FormatsReviewsPage($dataconnection, $id) {
        parent::CommonPage();
        $menu = new CommonFootMenu();
		$this->add_element(new ListReviewsElement(new FormatsReviewsMeta($dataconnection, $id)));
		$this->add_element(new MenuElement("FOOT", $menu));
    }
}

class YearsReviewsPage extends CommonPage {
    function YearsReviewsPage($dataconnection, $id) {
        parent::CommonPage();
        $menu = new CommonFootMenu();
		$this->add_element(new ListReviewsElement(new YearsReviewsMeta($dataconnection, $id)));
		$this->add_element(new MenuElement("FOOT", $menu));
    }
}

class FAQPage extends CommonPage {
    function FAQPage() {
        parent::CommonPage();
		$this->add_element(new MenuElement("FOOT", new CommonFootMenu()));
    }
}

class ArchivePage extends CommonPage {
    function ArchivePage($dataconnection, $current, $param) {
        parent::CommonPage();
        $tabs = new TabsHandler($current);
        $tabs->items[] = new MenuItem("Artists", "main.php?mode=archive&type=artists", "");
        $tabs->items[] = new MenuItem("Labels", "main.php?mode=archive&type=labels", "");
        $tabs->items[] = new MenuItem("Reviewers", "main.php?mode=archive&type=reviewers", "");
        $tabs->items[] = new MenuItem("Formats", "main.php?mode=archive&type=formats", "");
        $tabs->items[] = new MenuItem("Years", "main.php?mode=archive&type=years", "");
        $tabs->current = strtolower($current);
        $lettersmeta = new LettersMeta($dataconnection, $current);
        $this->add_element(new TabsElement($tabs, $param));
        $this->add_element(new LettersElement($lettersmeta, $current, $param));
        $this->add_element(new ArchiveElement(new ArchiveMeta($dataconnection, $current, $param)));
		$this->add_element(new MenuElement("FOOT", new CommonFootMenu()));
    }
}

class ProgramsPage extends CommonPage {
    function ProgramsPage($dataconnection) {
        parent::CommonPage();
        $this->add_element(new ProgramsElement(new ProgramsMeta($dataconnection)));
		$this->add_element(new MenuElement("FOOT", new CommonFootMenu()));
    }
}

class StoryPage extends CommonPage {
    function StoryPage($dataconnection, $filename) {
        parent::CommonPage();
        $this->add_element(new StoryElement($filename));
        $id = 0;
        if (preg_match("/^(tale([0-9]{3})\.txt)$/", $filename, $matches))
            $id = intval($matches[2]);
        $gallerymeta = new GaleryMeta($dataconnection, 2, $id);
        if (count($gallerymeta->data) > 0)
            $this->add_element(new GaleryElement($gallerymeta));
		$this->add_element(new MenuElement("FOOT", new CommonFootMenu()));
    }
}

class StoriesPage extends CommonPage {
    function StoriesPage() {
        parent::CommonPage();
        $this->add_element(new StoriesElement());
		$this->add_element(new MenuElement("FOOT", new CommonFootMenu()));
    }
}

class UploadPage extends CommonPage {
    function UploadPage($dbconnection) {
        parent::CommonPage();
		$this->add_element(new MenuElement("FOOT", new CommonFootMenu()));
		if (array_key_exists("cover", $_FILES))
            $this->add_element(new FileUploadElement($_FILES['cover'], '/cover\.(jpg|jpeg|gif|png)$/i', $_REQUEST['password']));
		if (array_key_exists("review", $_FILES))
            $this->add_element(new FileUploadElement($_FILES['review'], '/new_review\.(txt)$/i', $_REQUEST['password']));
		if (array_key_exists("nfo", $_FILES))
            $this->add_element(new FileUploadElement($_FILES['nfo'], '/.*\.(nfo)$/i', $_REQUEST['password'], "", 'nfo'));
        if (array_key_exists("photo", $_FILES))
    		$this->add_element(new FileUploadElement($_FILES['photo'], '/.*\.(jpg)$/i', $_REQUEST['password'], "photos/", 'photo'));
        if (array_key_exists("changes", $_FILES))
    		$this->add_element(new FileUploadElement($_FILES['changes'], '/changes\.txt$/i', $_REQUEST['password'], "", 'changes'));
        $this->add_element(new ActionsListElement(new ActionsMeta($dbconnection)));
    }
}

class SearchResultsPage extends CommonPage {
    function SearchResultsPage($dataconnection, $type, $searchstr) {
        parent::CommonPage();
		$this->add_element(new MenuElement("FOOT", new CommonFootMenu()));
		$searchmeta = new SearchMeta($dataconnection, $type, $searchstr);
		$this->add_element(new SearchElement($searchmeta, $type, $searchstr));
    }
}

class ActionPage extends CommonPage {
    function ActionPage($alias, $dbconnection) {
        parent::CommonPage();
		$this->add_element(new MenuElement("FOOT", new CommonFootMenu()));
		$factory = new ActionFactory($dbconnection);
        $action = $factory->get_action($alias);
        $action->perform();
		$this->add_element(new ActionElement($action));
    }
}

?>
