# Dump of database ior from server localhost
# Time of dump: Saturday, 26 August 2006  13:03:14

#Table actions

DROP TABLE IF EXISTS actions;

CREATE TABLE actions (
 ouid int(10) unsigned NOT NULL  auto_increment,
 name varchar(45) NOT NULL ,
 query text NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table artists

DROP TABLE IF EXISTS artists;

CREATE TABLE artists (
 ouid int(10) unsigned NOT NULL  auto_increment,
 show_title varchar(50) NOT NULL ,
 base_title varchar(50) NOT NULL ,
 letter char(1) NOT NULL ,
 old_artist varchar(50),
 PRIMARY KEY (ouid)
);

#Table artists_links

DROP TABLE IF EXISTS artists_links;

CREATE TABLE artists_links (
 ouid int(10) unsigned NOT NULL  auto_increment,
 artist1 int(10) unsigned DEFAULT '0' NOT NULL ,
 artist2 int(10) unsigned DEFAULT '0' NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table dates

DROP TABLE IF EXISTS dates;

CREATE TABLE dates (
 ouid int(10) unsigned NOT NULL  auto_increment,
 date datetime DEFAULT '0000-00-00 00:00:00' NOT NULL ,
 body varchar(150) NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table discographies

DROP TABLE IF EXISTS discographies;

CREATE TABLE discographies (
 ouid int(10) unsigned NOT NULL  auto_increment,
 band varchar(45) NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table disk

DROP TABLE IF EXISTS disk;

CREATE TABLE disk (
 ouid int(10) unsigned NOT NULL  auto_increment,
 subtitle varchar(100),
 subimage varchar(8) NOT NULL ,
 release int(10) unsigned DEFAULT '0' NOT NULL ,
 format varchar(10) NOT NULL ,
 id int(10) unsigned DEFAULT '0' NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table faq

DROP TABLE IF EXISTS faq;

CREATE TABLE faq (
 ouid int(10) unsigned NOT NULL  auto_increment,
 question text,
 answer text,
 PRIMARY KEY (ouid)
);

#Table galeries

DROP TABLE IF EXISTS galeries;

CREATE TABLE galeries (
 ouid int(10) unsigned NOT NULL  auto_increment,
 type int(10) unsigned DEFAULT '0' NOT NULL ,
 id int(10) unsigned DEFAULT '0' NOT NULL ,
 photo varchar(20) NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table labels

DROP TABLE IF EXISTS labels;

CREATE TABLE labels (
 ouid int(10) unsigned NOT NULL  auto_increment,
 title varchar(50) NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table news

DROP TABLE IF EXISTS news;

CREATE TABLE news (
 ouid int(10) unsigned NOT NULL  auto_increment,
 body text NOT NULL ,
 date datetime DEFAULT '0000-00-00 00:00:00' NOT NULL ,
 image varchar(45) NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table notices

DROP TABLE IF EXISTS notices;

CREATE TABLE notices (
 ouid int(10) unsigned NOT NULL  auto_increment,
 date datetime DEFAULT '0000-00-00 00:00:00' NOT NULL ,
 body text NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table photo_desc

DROP TABLE IF EXISTS photo_desc;

CREATE TABLE photo_desc (
 ouid int(10) unsigned NOT NULL  auto_increment,
 description text NOT NULL ,
 place varchar(45) NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table photos

DROP TABLE IF EXISTS photos;

CREATE TABLE photos (
 ouid int(10) unsigned NOT NULL  auto_increment,
 photo varchar(10) DEFAULT '0' NOT NULL ,
 description int(10) unsigned DEFAULT '0' NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table programs

DROP TABLE IF EXISTS programs;

CREATE TABLE programs (
 ouid int(10) unsigned NOT NULL  auto_increment,
 name varchar(45) NOT NULL ,
 desc text NOT NULL ,
 dir varchar(45) NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table release

DROP TABLE IF EXISTS release;

CREATE TABLE release (
 ouid int(10) unsigned NOT NULL  auto_increment,
 title varchar(100) NOT NULL ,
 type varchar(10) NOT NULL ,
 year int(10) unsigned DEFAULT '0' NOT NULL ,
 label int(10) unsigned DEFAULT '0' NOT NULL ,
 artist int(10) unsigned DEFAULT '0' NOT NULL ,
 format varchar(10) NOT NULL ,
 old_release varchar(50),
 PRIMARY KEY (ouid)
);

#Table resource

DROP TABLE IF EXISTS resource;

CREATE TABLE resource (
 ouid int(10) unsigned NOT NULL  auto_increment,
 text varchar(255) NOT NULL ,
 lang varchar(20) NOT NULL ,
 code int(10) unsigned DEFAULT '0' NOT NULL ,
 section int(10) unsigned DEFAULT '0' NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table resume_quals

DROP TABLE IF EXISTS resume_quals;

CREATE TABLE resume_quals (
 ouid int(10) unsigned NOT NULL  auto_increment,
 resource_ouid int(10) unsigned DEFAULT '0' NOT NULL ,
 text varchar(100) NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table review

DROP TABLE IF EXISTS review;

CREATE TABLE review (
 ouid int(10) unsigned NOT NULL  auto_increment,
 release int(10) unsigned DEFAULT '0' NOT NULL ,
 review_text text NOT NULL ,
 author varchar(40) NOT NULL ,
 date datetime DEFAULT '0000-00-00 00:00:00' NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table review_plan

DROP TABLE IF EXISTS review_plan;

CREATE TABLE review_plan (
 ouid int(10) unsigned NOT NULL  auto_increment,
 rev_id int(10) unsigned DEFAULT '0' NOT NULL ,
 release varchar(60) NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table thanks

DROP TABLE IF EXISTS thanks;

CREATE TABLE thanks (
 ouid int(10) unsigned NOT NULL  auto_increment,
 FullName varchar(60) NOT NULL ,
 WhatFor varchar(60) NOT NULL ,
 url varchar(60) NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table tracks

DROP TABLE IF EXISTS tracks;

CREATE TABLE tracks (
 ouid int(10) unsigned NOT NULL  auto_increment,
 title varchar(140),
 duration int(10) unsigned,
 PRIMARY KEY (ouid)
);

#Table tracks_data

DROP TABLE IF EXISTS tracks_data;

CREATE TABLE tracks_data (
 ouid int(10) unsigned NOT NULL  auto_increment,
 title varchar(150) NOT NULL ,
 duration int(10) unsigned DEFAULT '0' NOT NULL ,
 diskouid int(10) unsigned DEFAULT '0' NOT NULL ,
 track_number int(10) unsigned DEFAULT '0' NOT NULL ,
 PRIMARY KEY (ouid)
);

#Table tracks_link

DROP TABLE IF EXISTS tracks_link;

CREATE TABLE tracks_link (
 ouid int(10) unsigned NOT NULL  auto_increment,
 track int(10) unsigned DEFAULT '0' NOT NULL ,
 disc int(10) unsigned DEFAULT '0' NOT NULL ,
 track_number int(10) unsigned DEFAULT '0' NOT NULL ,
 PRIMARY KEY (ouid)
);