<?php

	// here is Template class is defined
	require('template.php');
	// classes of Lev's Reviews Machine
	require('lrm-sources/images.php');
	require('lrm-sources/pages.php');

	$httphost = $_SERVER["HTTP_HOST"];

	// database parameters
	if(strpos(".".$httphost,"localhost")>0) {
        $connectionspec = new LocalhostConnectionSpec();
	} else {
        $connectionspec = new WorkConnectionSpec();
	}
    $dbconnection = new MySQLDataSource($connectionspec);
    if (count($dbconnection->errors) > 0) {
        $pageevent = new PageEvent("error", $dbconnection->errors[0]);
        $dbconnection->clearerrors();
    }
	if(strpos(".".$httphost,"localhost")>0) {
		mysql_query("SET CHARACTER SET cp1251");
	}

	$template = new Template();

	$mode = "main";
	if(array_key_exists("mode",$_REQUEST)) $mode = $_REQUEST["mode"];
	
	// global templates variables
	$template->assign_vars(array(
		"YEARS" => "1997-2006",
		"HTTP_HOST" => "http://".$_SERVER["HTTP_HOST"]."/reviews/")
	);
	
	if (!isset($pageevent)) {
    	$requestdispatcher = new IORDispatcher(new RequestMeta($dbconnection));
    	$address = $_SERVER["REQUEST_URI"];
    	if(array_key_exists("REDIRECT_URL",$_SERVER)) $address = $_SERVER["REDIRECT_URL"];
        $pageevent = $requestdispatcher->dispatch($address);
    }

	switch ($pageevent->name) {
        case "error":
            $template->set_filenames(array(
                "body" => "templates/error.tpl",
                "image" => "templates/img.tpl")
            );
            $page = new ErrorPage($pageevent->param1);
            break;
        case "main":
            $template->set_filenames(array(
                "body" => "templates/main.tpl",
                "image" => "templates/img.tpl"
            ));
            $page = new MainPage($dbconnection);
            break;
        case "recent":
            $template->set_filenames(array(
                "body" => "templates/recent.tpl",
                "image" => "templates/img.tpl"
            ));
            $page = new RecentPage($dbconnection);
            break;
        case "review":
            $template->set_filenames(array(
                "body" => "templates/review.tpl",
                "image" => "templates/img.tpl"
            ));
            $page = new ReviewPage($dbconnection, $pageevent->param1);
            break;
        case "reviews":
            $template->set_filenames(array(
                "body" => "templates/reviews_list.tpl",
                "image" => "templates/img.tpl"
            ));
            switch ($pageevent->param1) {
                case "artist":
                    $page = new ArtistReviewsPage($dbconnection, $pageevent->param2);
                    break;
                case "label":
                    $page = new LabelReviewsPage($dbconnection, $pageevent->param2);
                    break;
                case "reviewer":
                    $page = new ReviewersReviewsPage($dbconnection, $pageevent->param2);
                    break;
                case "format":
                    $page = new FormatsReviewsPage($dbconnection, $pageevent->param2);
                    break;
                case "year":
                    $page = new YearsReviewsPage($dbconnection, $pageevent->param2);
                    break;
            }
            break;
        case "archive":
            $template->set_filenames(array(
                "body" => "templates/archive.tpl",
                "image" => "templates/img.tpl"
            ));
            $page = new ArchivePage($dbconnection, $pageevent->param1, $pageevent->param2);
            break;
        case "faq":
            $template->set_filenames(array(
                "body" => "templates/faq.tpl",
                "image" => "templates/img.tpl"
            ));
            $page = new FAQPage();
            break;
        case "author":
            $template->set_filenames(array(
                "body" => "templates/author.tpl",
                "image" => "templates/img.tpl"
            ));
            $page = new AuthorPage($dbconnection);
            break;
        case "programs":
            $template->set_filenames(array(
                "body" => "templates/programs.tpl",
                "image" => "templates/img.tpl"
            ));
            $page = new ProgramsPage($dbconnection);
            break;
        case "story":
            $template->set_filenames(array(
                "body" => "templates/story.tpl",
                "image" => "templates/img.tpl"
            ));
            $page = new StoryPage($dbconnection, $pageevent->param1);
            break;
        case "stories":
            $template->set_filenames(array(
                "body" => "templates/stories.tpl",
                "image" => "templates/img.tpl"
            ));
            $page = new StoriesPage();
            break;
        case "search":
            $template->set_filenames(array(
                "body" => "templates/search.tpl",
                "image" => "templates/img.tpl"
            ));
            $page = new SearchResultsPage($dbconnection, $pageevent->param1, $pageevent->param2);
            break;
        case "upload":
            $template->set_filenames(array(
                "body" => "templates/upload.tpl",
                "image" => "templates/img.tpl"
            ));
            $page = new UploadPage($dbconnection);
            break;
        case "action":
            $template->set_filenames(array(
                "body" => "templates/action.tpl",
                "image" => "templates/img.tpl"
            ));
            $page = new ActionPage($pageevent->param1, $dbconnection);
            break;
    }
    // if error occured while evaluating
    $allerrors = $dbconnection->errors;
    foreach ($page->elements as $element) {
        foreach ($element->errors as $error) {
            $allerrors[] = $error;
        }
    }
    if (count($allerrors) > 0) {
        $template->set_filenames(array(
            "body" => "templates/error.tpl",
            "image" => "templates/img.tpl")
        );
        $page = new ErrorPage($allerrors);
    }
    $page->prepare($template);
    $template->pparse("body");

	$dbconnection->close();

?>
